/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Googlebar for Mozilla.
 *
 * The Initial Developer of the Original Code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Boughton
 *  Andrew Houghton
 *  John Woods
 *  Bernd Kuemmerlen
 *  Robert Mulcahy
 *  Alfred Kayser
 *  Reflex
 *  Gary Turnbull
 *  Raj Bhaskar
 *  Joachim Thewes
 *  Henrik Gemal
 *  Robert Fernandes
 *  Joe Chellman
 *  Franki Cheung
 *  Alban Fonrouge
 *  Martin Hassman
 *  Ufuk Kayserilioglu
 *  Yoni Gilad
 *  Tim Schmidt
 *  timeless
 *  Francis Turner
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// Login Manager: Searching for logins matching host: https://mail.google.com, formSubmitURL: null, httpRealm: New mail feed

const GB_DEFAULT_DELAY = 5;
const GB_GMAIL_ATOM_URL = 'https://mail.google.com/mail/feed/atom';
const GB_GMAIL_AUTH_URL = 'https://www.google.com/accounts/ServiceLoginBoxAuth';
const GB_GMAIL_HTML_URL = 'https://mail.google.com/mail/h/';

const GB_GMAIL_NOTIFY_URL = 'chrome://googlebar/skin/sound/boing.wav';

var ggb_FireFox3g = false ;

if ("@mozilla.org/passwordmanager;1" in Components.classes) {
   // Password Manager exists so this is not Firefox 3 (could be Firefox 2, Netscape, SeaMonkey, etc).
   // Password Manager code
   // GB_PASSWD is Used to add a username/password to the store.
   // GB_PASSWD_INT is used to find an entry.

   ggb_FireFox3g = false ;
    try {

      const GB_PASSWD = Components.classes["@mozilla.org/passwordmanager;1"]
                                     .createInstance(Components.interfaces.nsIPasswordManager);
      const GB_PASSWD_INT = Components.classes["@mozilla.org/passwordmanager;1"]
                                     .createInstance(Components.interfaces.nsIPasswordManagerInternal);
    }
    catch (e) {
      myGooglebarUtil.logMessage("Failed to initialize Old style password manager\n" + e);
      myGooglebarUtil.logMessage("Running Firefox 3 login style\n");

    }


}
if ("@mozilla.org/login-manager;1" in Components.classes) {
  // Login Manager exists so this is Firefox 3
  ggb_FireFox3g = true ;
    try {

  // Get a nsLoginInfo object, initialized.
  var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
                         Components.interfaces.nsILoginInfo,"init");

  // Get Login Manager
  var myLoginManager = Components.classes["@mozilla.org/login-manager;1"]
                         .getService(Components.interfaces.nsILoginManager);
  }
    catch (e) {
      myGooglebarUtil.logMessage("Failed to initialize Firefox 3.x+ password manager\n" + e);
    }

}


var myGooglebarMail = {

	/*** Variable Declarations ***/

	mAuthenticated: false,
	mMessages: new Array(),
	mRequest: null,
	mPolling: false,
	mTimeoutDelay: 300000,

// nsLoginInfo structure data
ggb_hostname : "https://www.google.com",
ggb_formSubmitURL : "https://www.google.com",
ggb_httprealm : null,
ggb_username : "" ,
ggb_password : "" ,
ggb_usernameField : "Email" ,
ggb_passwordField : "Passwd" ,
ggb_FireFox3 : false ,
ggb_passwordFound : false ,

	/*** Function Declarations ***/

	authenticate: function(aEvent) {
		if (this.mAuthenticated) { return; }

		var myID = myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_USERID_NAME);

		var host = {value:""};
		var user =  {value:""};
		var passwd = {value:""};

    if ( this.ggb_FireFox3 == false ) {
		try {
			GB_PASSWD_INT.findPasswordEntry(GB_GMAIL_AUTH_URL, myID, "", host, user, passwd);
      }
    catch(e){
        // this.ggb_FireFox3 = true ; // Should be redundant as we should already know this.
      }
    }

    if ( this.ggb_FireFox3 == true ) {
    try {

      var ggb_loginInfo1 = new nsLoginInfo(this.ggb_hostname, this.ggb_formSubmitURL, this.ggb_httprealm, myID, this.ggb_password,
                                      this.ggb_usernameField, this.ggb_passwordField);

      var logins = myLoginManager.getAllLogins({});

      // First, look for a specific userid paired to gmail, stored in the preferences. myID is usually not stored.
      for (var i = 0; i < logins.length; i++) {
          if (logins[i].username == myID && logins[i].formSubmitURL == this.ggb_formSubmitURL ) {
             passwd.value = logins[i].password ;
             user.value = logins[i].username ;
             host.value = logins[i].hostname ;
             this.ggb_username = user.value ;
             this.ggb_password = passwd.value ;
             this.ggb_passwordFound = true ;
             break;
          }
       }
      // passwd was not found by myID, so pick any passwd stored for gmail
      if( ! this.ggb_passwordFound ) {
      for (var i = 0; i < logins.length; i++) {
          if ( logins[i].formSubmitURL == this.ggb_formSubmitURL ) {
             passwd.value = logins[i].password ;
             user.value = logins[i].username ;
             host.value = logins[i].hostname ;
             this.ggb_username = user.value ;
             this.ggb_password = passwd.value ;
             this.ggb_passwordFound = true ;
             break;
            }
          }
       }

    }
    catch(ex) {
       // This will only happen if there is no nsILoginManager component class
      }
    }

		// We don't have a username or password after
		// looking in password manager, prompt user
		// and optionally store in password manager
		if ( ( user.value == "" ) || ( passwd.value == "" ) ) {
			myGooglebarUtil.logMessage("Username or password not found for GMail account, prompt user");

			if (myID && !user.value) {
				user.value = myID;
			}

			var check = {value:false};
			var ok = GB_PROMPT_SVC.promptUsernameAndPassword(window, myGooglebarUtil.getProperty('gb.pw_prompt.title'),
                myGooglebarUtil.getProperty('gb.pw_prompt.label') + '\n', user, passwd,
                myGooglebarUtil.getProperty('gb.pw_prompt.check'), check);

			if (!ok) {
				return;
			}
			if ( check.value && user.value && passwd.value) {

        if ( this.ggb_FireFox3 == false ) {
              GB_PASSWD.addUser(GB_GMAIL_AUTH_URL, user.value, passwd.value);
              myGooglebarPrefUtil.setPrefValue(GB_PREF_GMAIL_USERID_NAME, user.value);
              }

        if ( this.ggb_FireFox3 == true) {
              var ggb_loginInfo2 = new nsLoginInfo( this.ggb_hostname, this.ggb_formSubmitURL, this.ggb_httprealm,
              user.value, passwd.value, this.ggb_usernameField, this.ggb_passwordField);
              myGooglebarPrefUtil.setPrefValue(GB_PREF_GMAIL_USERID_NAME, user.value);

              try {
              myLoginManager.addLogin( ggb_loginInfo2 ); // This will fail everytime but the first... and it throws an exception.
              } catch(ex){ 	myGooglebarUtil.logMessage("Error adding Username or password to Firefox3 Password Manager");
              }
          }
       }
		}

		// Still don't have a username or password after
		// looking in password manager and after prompting
		// the user, just continue on to home page
		if (!user.value || !passwd.value) {
			myGooglebarUtil.logMessage("Username or password not found for GMail account, cannot use auto-login");
			return;
		}

		var data = "service=mail&Email=" + encodeURIComponent(user.value)
			+ "&Passwd=" + encodeURIComponent(passwd.value)
			+ "&null=Sign%20in&continue=" + myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_URL_NAME);

		var request = new XMLHttpRequest();
		request.open('POST', GB_GMAIL_AUTH_URL, false);
		request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		request.send(data);

		this.mAuthenticated = true;
	},

	autoLogin: function() {
		this.authenticate();
		// Set as authenticated regardless of result
		this.mAuthenticated = true;
	},

	initialize: function() {
		myGooglebarUtil.getElement("ggb_gmail_separate").addEventListener("DOMAttrModified", myGooglebarMail.listenButton, false);

    this.ggb_FireFox3 = ggb_FireFox3g ;
		if (myGooglebarPrefUtil.getPrefValue(GB_PREF_GOOGLE_LOGIN_NAME)) {
			this.autoLogin();
		}
		this.setTimeoutDelay(myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_DELAY_NAME));

		if (myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_UPDATE_NAME)) {
			this.startPolling();
		}
		//myGooglebarUtil.logMessage("Googlebar FF3 style:" +  ggb_FireFox3g );
	},

	getTimeoutDelay: function() {
		return this.mTimeoutDelay;
	},

	isPolling: function() {
		return this.mPolling;
	},

	listenButton: function(aEvent) {
		var btn = myGooglebarUtil.getElement("ggb_gmail_separate");

		if (aEvent && aEvent.attrName == 'label_ext') {
			if (aEvent.newValue) {
				if (btn.getAttribute("label") && btn.getAttribute("label").indexOf(btn.getAttribute("buttonlabel")) == 0) {
					btn.setAttribute("label", btn.getAttribute("buttonlabel") + " " + aEvent.newValue);
				}
				else {
					btn.setAttribute("label", aEvent.newValue);
				}
			}
			else {
				if (btn.getAttribute("label") && btn.getAttribute("label").indexOf(btn.getAttribute("buttonlabel")) == 0) {
					btn.setAttribute("label", btn.getAttribute("buttonlabel"));
				}
				else {
					btn.removeAttribute("label");
				}
			}
		}
	},

	notify: function(aSoundURL) {
		if (GB_SOUND_OBJ) {
			try {
				// No URL specified, use default
				if (!aSoundURL || aSoundURL.length == 0) {
					aSoundURL = GB_GMAIL_NOTIFY_URL;
				}
				// URL specified, if it's a file then convert it to a URI
				else if (!(/^(file|http|https):/.test(aSoundURL))) {
					aSoundURL = myGooglebarUtil.getFileURI(aSoundURL, true);

					// File does not exist, beep instead
					if (!aSoundURL || aSoundURL.length == 0) {
						aSoundURL = "";
					}
				}

				var soundURI = GB_IO_SVC.newURI(aSoundURL, null, null);
				GB_SOUND_OBJ.play(soundURI);
			}
			catch (e) {
				myGooglebarUtil.logMessage("Unable to play notification sound, beep instead");
				GB_SOUND_OBJ.beep();
			}
		}
		else {
			myGooglebarUtil.logMessage("Unable to play notification sound, no sound object found");
		}
	},

	openMail: function(aEvent) {
		this.authenticate(aEvent);
		myGooglebar.doAction(myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_URL_NAME), myGooglebar.getLocFromEvent(aEvent));
	},

	openMessage: function(aEvent, aSubject) {
		this.authenticate(aEvent);

		var myID = myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_USERID_NAME);

		var host = {value:""};
		var user =  {value:""};
		var passwd = {value:""};

		if (GB_PASSWD_INT) {
			try {
				GB_PASSWD_INT.findPasswordEntry(GB_GMAIL_AUTH_URL, myID, "", host, user, passwd);
			}
			catch (e) {
			}
		}

		if (!user.value || !passwd.value) {
			myGooglebarUtil.logMessage("Username or password not found for GMail account, cannot use navigation");
			myGooglebar.doAction(myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_URL_NAME), myGooglebar.getLocationFromEvent(aEvent));
			return;
		}

		try {
			var request = new XMLHttpRequest();
			request.open('GET', GB_GMAIL_HTML_URL, false, user.value, passwd.value);
			request.send(null);

			if (request.readyState == 4) {
				if (request.status == 200) {
					var result = request.responseText.replace(new RegExp("\n", "g"), "<!-- br -->");
					var regex = new RegExp(".*base href=\"(.*?)\".*href=\"(.*?)\".*?" + aSubject + ".*");
					if (regex.test(result)) {
						var base = RegExp.$1;
						var link = RegExp.$2;

						myGooglebar.doAction(base + link, myGooglebar.getLocFromEvent(aEvent));
					}
				}
				else {
					myGooglebarUtil.logMessage("Error loading navigation page");
				}
			}
		}
		catch (e) {
			myGooglebarUtil.logMessage("Error loading navigation page\n\n" + e);
		}
	},

	setTimeoutDelay: function(aDelay) {
		var regex = /(^\d+$)/;
		if (regex.test(aDelay) && aDelay > 0) {
			this.mTimeoutDelay = aDelay * 60000;
		}
		else {
			this.mTimeoutDelay = GB_DEFAULT_DELAY * 60000;
			myGooglebarUtil.logMessage("Invalid delay specified (" + aDelay + "), using default.");
		}
	},

	startPolling: function() {
		if (this.isPolling()) {
			return;
		}

		this.mPolling = true;
		setTimeout("myGooglebarMail.updateMail()", 1000);
	},

	stopPolling: function() {
		this.mPolling = false;
		this.updateButton(null);
	},

	updateButton: function(aResponse) {
		var msgs = aResponse ? aResponse.getElementsByTagName("entry").length : 0;
		var allmsgs = aResponse ? aResponse.getElementsByTagName("fullcount")[0].textContent : 0;
		var btn = myGooglebarUtil.getElement("ggb_gmail_separate");
		var pop = myGooglebarUtil.getElement("ggb_gmail_popup");
		var notify = false;

		if (btn) {
			while (pop.lastChild) {
				pop.removeChild(pop.lastChild);
			}

			if (msgs <= 0) {
				this.mMessages = new Array();
				btn.setAttribute("label_ext", "");
				btn.removeAttribute("type");
				btn.removeAttribute("container");
			}
			else {
				var oldLabel = btn.getAttribute("label");
				btn.setAttribute("label_ext", "(" + allmsgs + ")");

				btn.setAttribute("type", "menu-button");
				btn.setAttribute("container", "true");

				var resTitle, resSmry, resEmail, resID, menuitem;
				var entries = aResponse.getElementsByTagName("entry");

				for (var i = 0; i < entries.length; i++) {
					resTitle = unescape(entries[i].getElementsByTagName("title")[0].firstChild.nodeValue);
					resSmry = unescape(entries[i].getElementsByTagName("summary")[0].firstChild.nodeValue);
					resEmail = entries[i].getElementsByTagName("author")[0].getElementsByTagName("email")[0].firstChild.nodeValue;
					resID = entries[i].getElementsByTagName("id")[0].firstChild.nodeValue;

					menuitem = document.createElement("menuitem");
					menuitem.setAttribute("oncommand", "myGooglebarMail.openMessage(event, '" + resTitle.replace(/'/g, "\\'") + "'); event.preventBubble();");
					menuitem.setAttribute("label", '[' + resEmail + ']  ' + resTitle);
					menuitem.setAttribute("tooltiptext", resSmry);
					pop.appendChild(menuitem);

					if (myGooglebarUtil.arrayIndexOf(resID, this.mMessages) < 0) {
						this.mMessages[this.mMessages.length] = resID;
						notify = true;
					}
				}

				if (notify && myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_NOTIFY_ENABLED_NAME)) {
					this.notify(myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_NOTIFY_NAME));
				}
			}
		}
	},

	updateMail: function(aFailover) {
		if (!this.isPolling()) { return; }

		var myID = myGooglebarPrefUtil.getPrefValue(GB_PREF_GMAIL_USERID_NAME);

		var host = {value:""};
		var user =  {value:""};
		var passwd = {value:""};
//		var ggb_passwordFound = false ;
//		var ggb_FireFox3 = false ;
// DEBUG Essentially, GB_PASSWD_INT is Firefox 2.x and before
		if (GB_PASSWD_INT) {
			try {
				GB_PASSWD_INT.findPasswordEntry(GB_GMAIL_AUTH_URL, myID, "", host, user, passwd);
			}
			catch (e) {  // this.ggb_FireFox3 = true ; can be, but empty username can lead to prefname search failure, and empty test result.
			} // this will produce bad results when trying to determine which password manager to use. I may need to rewrite this thing.
		}

		else {
    if ( this.ggb_FireFox3 == true ) {
    try {

      var ggb_loginInfo3 = new nsLoginInfo( this.ggb_hostname, this.ggb_formSubmitURL, this.ggb_httprealm,
              myID, this.ggb_password, this.ggb_usernameField, this.ggb_passwordField);

      var logins = myLoginManager.getAllLogins({});

      // First, look for a specific userid paired to gmail, stored in the preferences. myID is usually not stored.
      for (var i = 0; i < logins.length; i++) {
          if (logins[i].username == myID && logins[i].formSubmitURL == this.ggb_formSubmitURL ) {
             passwd.value = logins[i].password ;
             user.value = logins[i].username ;
             host.value = logins[i].hostname ;

             this.ggb_passwordFound = true ;
             break;
          }
       }
      // passwd was not found by myID, so pick any passwd stored for gmail
      if( ! this.ggb_passwordFound ) {
      for (var i = 0; i < logins.length; i++) {
          if ( logins[i].formSubmitURL == this.ggb_formSubmitURL ) {
             passwd.value = logins[i].password ;
             user.value = logins[i].username ;
             host.value = logins[i].hostname ;
             this.ggb_passwordFound = true ;
             break;
            }
          }
       }

    }
    catch(ex) {
       // This will only happen if there is no nsILoginManager component class
          }
        } // this.ggb_FireFox3 == true
     } // else

    if ( (! this.ggb_username == "" ) && ( ! this.ggb_password == "" ) && this.ggb_FireFox3 ) {
          user.value = this.ggb_username.value ;
          passwd.value = this.ggb_password.value ;
    } // DEBUG this one too


		if ( !aFailover && ( user.value=="" || passwd.value=="" ) ) {
			this.authenticate();
			this.updateMail(true);
			return;
		}

		this.mRequest = new XMLHttpRequest();
// DEBUG is this assigned correctly in FF3
		if ( ( user.value=="" ) || ( passwd.value=="" ) ) {
			myGooglebarUtil.logMessage("Username or password not found for GMail account, cannot use auto-login");
			this.mRequest.open('GET', GB_GMAIL_ATOM_URL, true);
		}
		else {
			this.mRequest.open('GET', GB_GMAIL_ATOM_URL, true, user.value, passwd.value);
		}

		this.mRequest.onreadystatechange = function (aEvt) {
			try {
				if (!myGooglebarMail.isPolling()) { return; }

				if (myGooglebarMail.mRequest.readyState == 4) {
					if (myGooglebarMail.mRequest.status == 200) {
						var response = myGooglebarMail.mRequest.responseXML;
						myGooglebarMail.updateButton(response);
					}
					else {
						myGooglebarUtil.logMessage("Error loading GMail update page");
					}
				}
			}
			catch (e) {
				myGooglebarUtil.logMessage("Error loading GMail update page\n\n" + e);
			}
		};

		this.mRequest.send(null);

		setTimeout("myGooglebarMail.updateMail()", this.getTimeoutDelay());
	}
};

