/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Googlebar for Mozilla.
 *
 * The Initial Developer of the Original Code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Boughton
 *  Andrew Houghton
 *  John Woods
 *  Bernd Kuemmerlen
 *  Robert Mulcahy
 *  Alfred Kayser
 *  Reflex
 *  Gary Turnbull
 *  Raj Bhaskar
 *  Joachim Thewes
 *  Henrik Gemal
 *  Robert Fernandes
 *  Joe Chellman
 *  Franki Cheung
 *  Alban Fonrouge
 *  Martin Hassman
 *  Ufuk Kayserilioglu
 *  Yoni Gilad
 *  Tim Schmidt
 *  timeless
 *  Francis Turner
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const GB_SUGGEST_CMD = "myGooglebarSuggest.displaySuggest(";
const GB_SUGGEST_URL = "http://www.google.com/complete/search";

var myGooglebarSuggest = {

	mRequest: null,

	displaySuggest: function(aSearchString, aLabelArray, aResultArray, aOtherArray) {
	    var suggestPop = myGooglebarUtil.getElement("ggb_suggest_popup");
		var ndx;
		var tempNode;
		
		// clean up all of the popup menu items
		for (ndx = suggestPop.childNodes.length - 1; ndx >= 0; ndx--) {
			suggestPop.removeChild(suggestPop.childNodes[ndx]);
		}
		
		// add suggest items to the popup menu
		for (ndx = 0; ndx < aLabelArray.length; ndx++) {
		    tempNode = document.createElement("menuitem");
		    tempNode.setAttribute("label", aLabelArray[ndx] + " - " + aResultArray[ndx]);
		    tempNode.setAttribute("class", "ggb_css_menuitem_all");
		    tempNode.setAttribute("oncommand", "myGooglebarSuggest.searchSuggest(event, '" + aLabelArray[ndx] + "');");
		    suggestPop.appendChild(tempNode);
		}
		
		suggestPop.showPopup();
	},
	
	/*
	displaySuggest: function(aSearchString, aLabelArray, aResultArray, aOtherArray) {
		var display = "";
		
		display += " Google Suggest Result for '" + aSearchString + "'\n";
		display += "-------------------------------------------------\n";
	
		for (var i = 0; i < aLabelArray.length; i++) {
			display += aLabelArray[i];
			display += "\t\t";
			display += aResultArray[i];
			display += "\n";
		}
		
		alert(display);
	},
	*/
	
	searchSuggest: function(aEvent, aSearchString) {
		myGooglebarUtil.getElement("ggb_search_criteria").value = aSearchString;
		myGooglebar.clearTerms();
		myGooglebar.addTerms(aSearchString);
		myGooglebarHighlight.delayHighlight();
		myGooglebar.doSearch(aEvent);
	},
	
	suggest: function(aEvent) {
		var searchString = aEvent.target.value;

		if (myGooglebarUtil.trimString(searchString) == "")
			return;

		// Do not popup suggest if esc key
		if (aEvent.keyCode == 27)
			return;

		if (myGooglebarPrefUtil.getPrefValue(GB_PREF_GOOGLE_SUGGEST_NAME)) {
			if (myGooglebarPrefUtil.getPrefValue(GB_PREF_GOOGLE_SUGGEST_FREQ_NAME) == 1 && aEvent.keyCode != 32) {
				return;
			}
		}
		else {
			if (!(aEvent.keyCode == 32 && aEvent.ctrlKey)) {
				return;
			}
		}
		
		var searchURL = GB_SUGGEST_URL + "?hl=en&js=true&qu=" + searchString;
		this.mRequest = new XMLHttpRequest();
		this.mRequest.open('GET', searchURL, true);
		this.mRequest.onreadystatechange = function (aEvt) {
			try {
				if (myGooglebarSuggest.mRequest.readyState == 4) {
					if (myGooglebarSuggest.mRequest.status == 200) {
						var text = myGooglebarSuggest.mRequest.responseText
						var cmd = text.replace(/\s*sendRPCDone\(frameElement,\s*/, GB_SUGGEST_CMD);
						
						// Make sure we aren't running any commands that we don't expect to run
			
						if (cmd.indexOf(";") >= 0) {
							cmd = cmd.substring(0, cmd.indexOf(";"));
						}
						
						if (cmd.indexOf(GB_SUGGEST_CMD) == 0) {
							eval(cmd);
						}
						else {
							myGooglebarUtil.logMessage("This is not the expected suggest command.\n" + cmd);
						}
					}
					else {
						myGooglebarUtil.logMessage("Error loading Suggest update page");
					}
				}
			}
			catch (e) {
				myGooglebarUtil.logMessage("Error loading Suggest update page\n\n" + e);
			}
		};
		this.mRequest.send(null);
	}
};